---
 include/linux/init_task.h |    1 
 include/linux/mm.h        |   12 +
 include/linux/mm_types.h  |    3 
 include/linux/sptree.h    |   38 +++++
 kernel/fork.c             |    1 
 mm/Makefile               |    2 
 mm/vma-sptree.c           |  335 ++++++++++++++++++++++++++++++++++++++++++++++
 7 files changed, 391 insertions(+), 1 deletion(-)

Index: linux-2.6.29.y/include/linux/sptree.h
===================================================================
--- /dev/null
+++ linux-2.6.29.y/include/linux/sptree.h
@@ -0,0 +1,38 @@
+/*
+ * Splay Trees
+ *
+ * (C) 2009 Luiz Fernando N. Capitulino <lcapitulino@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *
+ *  This implementation is done in the Linux kernel's rbtree style, in
+ *  which the user has to implement his or her own insert and search
+ *  cores. This way we avoid callbacks and the associated performance
+ *  loss.
+ */
+#ifndef _LINUX_SPTREE_H
+#define _LINUX_SPTREE_H
+
+#include <linux/kernel.h>
+#include <linux/stddef.h>
+
+struct sp_node
+{
+	struct sp_node *sp_right;
+	struct sp_node *sp_left;
+};
+
+struct sp_root
+{
+	struct sp_node *sp_node;
+};
+
+#define SP_ROOT (struct sp_root) { NULL, }
+
+#define sp_entry(ptr, type, member) container_of(ptr, type, member)
+
+#endif /* _LINUX_SPTREE_H */
Index: linux-2.6.29.y/mm/vma-sptree.c
===================================================================
--- /dev/null
+++ linux-2.6.29.y/mm/vma-sptree.c
@@ -0,0 +1,335 @@
+/*
+ * VMA Splay Tree
+ *
+ * Luiz Fernando N. Capitulino
+ * <lcapitulino@gmail.com>
+ */
+#include <linux/mm_types.h>
+#include <linux/sptree.h>
+
+/*
+ * top_down_splay(): Splay Tree core. All functions use it but
+ * find_vma_prev().
+ */
+static struct vm_area_struct *top_down_splay(struct sp_node *root,
+					struct vm_area_struct **prev,
+					struct vm_area_struct **last,
+					unsigned long addr)
+{
+	struct sp_node *r, *l, nil;
+	struct vm_area_struct *node, *p, *pprev, *plast;
+
+	r = l = &nil;
+	nil.sp_left = nil.sp_right = NULL;
+	plast = pprev = NULL;
+	node = sp_entry(root, struct vm_area_struct, vm_sp);
+
+	for (;;) {
+		if (node->vm_end > addr) {
+			plast = node;
+
+			if (node->vm_start <= addr)
+				break;
+
+			if (!node->vm_sp.sp_left)
+				break;
+
+			p = sp_entry(node->vm_sp.sp_left,
+					struct vm_area_struct, vm_sp);
+			if (p->vm_end > addr) {
+				/* rotate right */
+				node->vm_sp.sp_left = p->vm_sp.sp_right;
+				p->vm_sp.sp_right = &node->vm_sp;
+				node = plast = p;
+
+				if (node->vm_start <= addr)
+					break;
+
+				if (!node->vm_sp.sp_left)
+					break;
+			}
+
+			/* link right */
+			r->sp_left = &node->vm_sp;
+			r = &node->vm_sp;
+			node = sp_entry(node->vm_sp.sp_left,
+					struct vm_area_struct, vm_sp);
+
+		} else {
+			pprev = node;
+
+			if (!node->vm_sp.sp_right)
+				break;
+
+			p = sp_entry(node->vm_sp.sp_right,
+					struct vm_area_struct, vm_sp);
+			if (p->vm_end <= addr) {
+				/* rotate left */
+				node->vm_sp.sp_right = p->vm_sp.sp_left;
+				p->vm_sp.sp_left = &node->vm_sp;
+				node = pprev = p;
+
+				if (!node->vm_sp.sp_right)
+					break;
+			}
+
+			/* link left */
+			l->sp_right = &node->vm_sp;
+			l = &node->vm_sp;
+			node = sp_entry(node->vm_sp.sp_right,
+					struct vm_area_struct, vm_sp);
+		}
+	}
+
+	/* assemble */
+	l->sp_right = node->vm_sp.sp_left;
+	r->sp_left = node->vm_sp.sp_right;
+	node->vm_sp.sp_left = nil.sp_right;
+	node->vm_sp.sp_right = nil.sp_left;
+
+	if (prev)
+		*prev = pprev;
+	if (last)
+		*last = plast;
+
+	return node;
+}
+
+/*
+ * find_vma_prev() with top-down splaying. Unfortunately it duplicates
+ * code from top_down_splay().
+ */
+struct vm_area_struct *sp_find_vma_prev(struct mm_struct *mm,
+					unsigned long addr,
+					struct vm_area_struct **prev)
+{
+	struct sp_node *r, *l, nil;
+	struct vm_area_struct *node, *p, *pprev, *vma;
+
+	pprev = vma = NULL;
+
+	if (unlikely(!mm) || unlikely(!mm->mm_sp.sp_node))
+		goto out;
+
+	vma = mm->mmap;
+	r = l = &nil;
+	nil.sp_left = nil.sp_right = NULL;
+	node = sp_entry(mm->mm_sp.sp_node, struct vm_area_struct, vm_sp);
+
+	for (;;) {
+		if (node->vm_end > addr) {
+			if (!node->vm_sp.sp_left)
+				break;
+
+			p = sp_entry(node->vm_sp.sp_left,
+					struct vm_area_struct, vm_sp);
+			if (p->vm_end > addr) {
+				/* rotate right */
+				node->vm_sp.sp_left = p->vm_sp.sp_right;
+				p->vm_sp.sp_right = &node->vm_sp;
+				node = p;
+
+				if (!node->vm_sp.sp_left)
+					break;
+			}
+
+			/* link right */
+			r->sp_left = &node->vm_sp;
+			r = &node->vm_sp;
+			node = sp_entry(node->vm_sp.sp_left,
+					struct vm_area_struct, vm_sp);
+
+		} else {
+			pprev = node;
+
+			if (!pprev->vm_next || (addr < pprev->vm_next->vm_end))
+				break;
+
+			if (!node->vm_sp.sp_right)
+				break;
+
+			p = sp_entry(node->vm_sp.sp_right,
+					struct vm_area_struct, vm_sp);
+			if (p->vm_end <= addr) {
+				/* rotate left */
+				node->vm_sp.sp_right = p->vm_sp.sp_left;
+				p->vm_sp.sp_left = &node->vm_sp;
+				node = pprev = p;
+
+				if (!pprev->vm_next ||
+						(addr < pprev->vm_next->vm_end))
+					break;
+
+				if (!node->vm_sp.sp_right)
+					break;
+			}
+
+			/* link left */
+			l->sp_right = &node->vm_sp;
+			l = &node->vm_sp;
+			node = sp_entry(node->vm_sp.sp_right,
+					struct vm_area_struct, vm_sp);
+		}
+	}
+
+	/* assemble */
+	l->sp_right = node->vm_sp.sp_left;
+	r->sp_left = node->vm_sp.sp_right;
+	node->vm_sp.sp_left = nil.sp_right;
+	node->vm_sp.sp_right = nil.sp_left;
+
+	mm->mm_sp.sp_node = &node->vm_sp;
+
+out:
+	*prev = pprev;
+	return pprev ? pprev->vm_next : vma;
+}
+
+struct vm_area_struct *sp_find_vma(struct mm_struct *mm,
+				unsigned long addr,
+				struct vm_area_struct **pprev)
+{
+	struct vm_area_struct *p, *last;
+
+	if (unlikely(!mm->mm_sp.sp_node))
+		return NULL;
+
+	p = top_down_splay(mm->mm_sp.sp_node, pprev, &last, addr);
+	mm->mm_sp.sp_node = &p->vm_sp;
+
+	return ((p->vm_end > addr && p->vm_start <= addr) ? p : last);
+}
+
+void sp_vma_insert(struct mm_struct *mm, struct vm_area_struct *new,
+		struct vm_area_struct **prev, struct vm_area_struct **parent)
+{
+	struct sp_node **root = &mm->mm_sp.sp_node;
+	struct vm_area_struct *node, *pparent = NULL;
+
+	if (unlikely(*root == NULL)) {
+		new->vm_sp.sp_left = new->vm_sp.sp_right = NULL;
+		if (prev)
+			*prev = NULL;
+		goto out;
+	}
+
+	node = top_down_splay(*root, prev, NULL, new->vm_start);
+
+	if (node->vm_end > new->vm_start) {
+		new->vm_sp.sp_left = node->vm_sp.sp_left;
+		new->vm_sp.sp_right = &node->vm_sp;
+		node->vm_sp.sp_left = NULL;
+		pparent = node;
+	} else {
+		/* node->vm_end <= new->vm_start */
+		new->vm_sp.sp_right = node->vm_sp.sp_right;
+		new->vm_sp.sp_left = &node->vm_sp;
+		node->vm_sp.sp_right = NULL;
+	}
+
+out:
+	*root = &new->vm_sp;
+	if (parent)
+		*parent = pparent;
+}
+
+void sp_vma_erase(struct mm_struct *mm, struct vm_area_struct *vma)
+{
+	struct vm_area_struct *node, *new_root;
+	struct sp_node **root = &mm->mm_sp.sp_node;
+
+	if (unlikely(*root == NULL))
+		return;
+
+	node = top_down_splay(*root, NULL, NULL, vma->vm_start);
+
+	if (!node->vm_sp.sp_left) {
+		new_root = sp_entry(node->vm_sp.sp_right,
+				struct vm_area_struct, vm_sp);
+	} else {
+		new_root = top_down_splay(node->vm_sp.sp_left, NULL, NULL,
+						vma->vm_start);
+		new_root->vm_sp.sp_right = node->vm_sp.sp_right;
+	}
+
+	*root = &new_root->vm_sp;
+}
+
+#if 0
+
+/* debug functions */
+
+void sp_show_tree(const struct vm_area_struct *vma)
+{
+	if (!vma)
+		return;
+
+	printk("-> 0x%lx-0x%lx\n", vma->vm_start, vma->vm_end);
+	if (vma->vm_sp.sp_left)
+		sp_show_tree(sp_entry(vma->vm_sp.sp_left,
+					struct vm_area_struct, vm_sp));
+	if (vma->vm_sp.sp_right)
+		sp_show_tree(sp_entry(vma->vm_sp.sp_right,
+					struct vm_area_struct, vm_sp));
+}
+
+/* read-only find_vma_prev() version */
+struct vm_area_struct *
+sp_find_vma_prev(struct mm_struct *mm, unsigned long addr,
+			struct vm_area_struct **pprev)
+{
+	struct sp_node *sp_node;
+	struct vm_area_struct *vma = NULL, *prev = NULL;
+
+	if (!mm)
+		goto out;
+
+	/* Guard against addr being lower than the first VMA */
+	vma = mm->mmap;
+
+	sp_node = mm->mm_sp.sp_node;
+
+	while (sp_node) {
+		struct vm_area_struct *vma_tmp;
+		vma_tmp = sp_entry(sp_node, struct vm_area_struct, vm_sp);
+
+		if (addr < vma_tmp->vm_end) {
+			sp_node = sp_node->sp_left;
+		} else {
+			prev = vma_tmp;
+			if (!prev->vm_next || (addr < prev->vm_next->vm_end))
+				break;
+			sp_node = sp_node->sp_right;
+		}
+	}
+
+out:
+	*pprev = prev;
+	return prev ? prev->vm_next : vma;
+}
+
+/* read-only find_vma() version */
+struct vm_area_struct *sp_ro_find_vma(struct mm_struct *mm, unsigned long addr)
+{
+	struct vm_area_struct *vma = NULL;
+	struct sp_node *sp_node = mm->mm_sp.sp_node;
+
+	while (sp_node) {
+		struct vm_area_struct *vma_tmp;
+
+		vma_tmp = sp_entry(sp_node,
+				struct vm_area_struct, vm_sp);
+
+		if (vma_tmp->vm_end > addr) {
+			vma = vma_tmp;
+			if (vma_tmp->vm_start <= addr)
+				break;
+			sp_node = sp_node->sp_left;
+		} else {
+			sp_node = sp_node->sp_right;
+		}
+	}
+
+	return vma;
+}
+#endif
Index: linux-2.6.29.y/include/linux/init_task.h
===================================================================
--- linux-2.6.29.y.orig/include/linux/init_task.h
+++ linux-2.6.29.y/include/linux/init_task.h
@@ -30,6 +30,7 @@ extern struct fs_struct init_fs;
 #define INIT_MM(name) \
 {			 					\
 	.mm_rb		= RB_ROOT,				\
+	.mm_sp		= SP_ROOT,				\
 	.pgd		= swapper_pg_dir, 			\
 	.mm_users	= ATOMIC_INIT(2), 			\
 	.mm_count	= ATOMIC_INIT(1), 			\
Index: linux-2.6.29.y/include/linux/mm_types.h
===================================================================
--- linux-2.6.29.y.orig/include/linux/mm_types.h
+++ linux-2.6.29.y/include/linux/mm_types.h
@@ -8,6 +8,7 @@
 #include <linux/spinlock.h>
 #include <linux/prio_tree.h>
 #include <linux/rbtree.h>
+#include <linux/sptree.h>
 #include <linux/rwsem.h>
 #include <linux/completion.h>
 #include <linux/cpumask.h>
@@ -132,6 +133,7 @@ struct vm_area_struct {
 	unsigned long vm_flags;		/* Flags, see mm.h. */
 
 	struct rb_node vm_rb;
+	struct sp_node vm_sp;
 
 	/*
 	 * For areas with an address space and backing store,
@@ -190,6 +192,7 @@ struct core_state {
 struct mm_struct {
 	struct vm_area_struct * mmap;		/* list of VMAs */
 	struct rb_root mm_rb;
+	struct sp_root mm_sp;
 	struct vm_area_struct * mmap_cache;	/* last find_vma result */
 	unsigned long (*get_unmapped_area) (struct file *filp,
 				unsigned long addr, unsigned long len,
Index: linux-2.6.29.y/kernel/fork.c
===================================================================
--- linux-2.6.29.y.orig/kernel/fork.c
+++ linux-2.6.29.y/kernel/fork.c
@@ -281,6 +281,7 @@ static int dup_mmap(struct mm_struct *mm
 	mm->map_count = 0;
 	cpus_clear(mm->cpu_vm_mask);
 	mm->mm_rb = RB_ROOT;
+	mm->mm_sp = SP_ROOT;
 	rb_link = &mm->mm_rb.rb_node;
 	rb_parent = NULL;
 	pprev = &mm->mmap;
Index: linux-2.6.29.y/mm/Makefile
===================================================================
--- linux-2.6.29.y.orig/mm/Makefile
+++ linux-2.6.29.y/mm/Makefile
@@ -11,7 +11,7 @@ obj-y			:= bootmem.o filemap.o mempool.o
 			   maccess.o page_alloc.o page-writeback.o pdflush.o \
 			   readahead.o swap.o truncate.o vmscan.o shmem.o \
 			   prio_tree.o util.o mmzone.o vmstat.o backing-dev.o \
-			   page_isolation.o mm_init.o $(mmu-y)
+			   page_isolation.o mm_init.o vma-sptree.o $(mmu-y)
 
 obj-$(CONFIG_PROC_PAGE_MONITOR) += pagewalk.o
 obj-$(CONFIG_BOUNCE)	+= bounce.o
Index: linux-2.6.29.y/include/linux/mm.h
===================================================================
--- linux-2.6.29.y.orig/include/linux/mm.h
+++ linux-2.6.29.y/include/linux/mm.h
@@ -1129,6 +1129,18 @@ extern void exit_mmap(struct mm_struct *
 extern int mm_take_all_locks(struct mm_struct *mm);
 extern void mm_drop_all_locks(struct mm_struct *mm);
 
+/* vma-sptree.c */
+void sp_vma_insert(struct mm_struct *mm, struct vm_area_struct *new,
+		struct vm_area_struct **prev, struct vm_area_struct **parent);
+struct vm_area_struct *sp_find_vma(struct mm_struct *mm,
+				unsigned long addr,
+				struct vm_area_struct **pprev);
+struct vm_area_struct *sp_ro_find_vma(struct mm_struct *mm, unsigned long addr);
+struct vm_area_struct *
+sp_find_vma_prev(struct mm_struct *mm, unsigned long addr,
+			struct vm_area_struct **pprev);
+void sp_vma_erase(struct mm_struct *mm, struct vm_area_struct *vma);
+
 #ifdef CONFIG_PROC_FS
 /* From fs/proc/base.c. callers must _not_ hold the mm's exe_file_lock */
 extern void added_exe_file_vma(struct mm_struct *mm);
